Unit MKNetB;
{$I MKB.Def}

{
     MKNetB - Copyright 1993 by Mark May - MK Software
     You are free to use this code in your programs, however
     it may not be included in Source/TPU function libraries
     without my permission.

     Mythical Kingom Tech BBS (513)237-7737 HST/v32
     FidoNet: 1:110/290
     Rime: ->MYTHKING
     You may also reach me at maym@dmapub.dma.org
}


Interface

Type NCBType = Record
  Command: Byte;
  ReturnCode: Byte;
  LSN: Byte;
  NcbNum: Byte;
  Buffer: Pointer;
  BufferLen: Word;
  NameRemote: Array[1..16] of Char;
  NameLocal: Array[1..16] of Char;
  TimeOut: Byte; {in 1/2 seconds}
  SendTimeOut: Byte;
  PostHdlr: Pointer;
  AdapterNum: Byte;
  CompleteCode: Byte;
  Rsvd: Array[1..14] of Byte;
  End;


Type NBSessionType = Record
  LSN: Byte;
  State: Byte;
  LocalName: Array[1..16] of Char;
  RemoteName: Array[1..16] of Char;
  OutStandingRcv: Byte;
  OutStandingSend: Byte;
  End;


Type NBStatusType = Record
  NumSessions: Byte;
  ThisNameSessions: Byte;
  OutstandingRcv: Byte;
  OutStandingAnys: Byte;
  Sessions: Array[1..255] of NBSessionType;
  End;


Function  LanInstalled: Boolean;
Procedure InitializeNCB(Var NCB: NCBType); {Normally internal use only}
Function  NBIntr(Var NCB: NCBType): Byte; {Normally internal use only}
Function  NBAddName(Name: String; Var NameNum: Byte): Byte;
Function  NBDeleteName(Name: String): Byte;
Function  NBCallFinished(Var NCB: NCBType; NBLimit: LongInt): Byte;
  {Normally internal use only}
Function  NBCall(RemoteName: String; LocalName: String; Var NCB: NCBType): Byte;
Function  NBListen(RemoteName: String; LocalName: String; Var NCB: NCBType): Byte;
Function  NBSendString(Var NCB: NCBType; LSN: Byte; Var Str: String): Byte;
Function  NBSendStringLimit(Var NCB: NCBType; LSN: Byte; Var Str: String; TLimit: LongInt): Byte;
Function  NBSendStringNW(Var NCB: NCBType; LSN: Byte; Var Str: String): Byte;
Function  NBSendBlockNW(Var NCB: NCBType; LSN: Byte; Var Buffer; BLen: Word): Byte;
Function  NBRecvString(Var NCB: NCBType; LSN: Byte; Var Str: String): Byte;
Function  NBRecvStringNW(Var NCB: NCBType; LSN: Byte; Var Str: String): Byte;
Function  NBRecvStringLimit(Var NCB: NCBType; LSN: Byte; Var Str: String; TLimit: LongInt): Byte;
Function  NBHangUp(LSN: Byte): Byte;
Function  NBCancel(Var NCB: NCBType): Byte; {Cancel pending request}
Function  NBGetStatus(Name: String; Var NBStat: NBStatusType): Byte;


Const
  LanAdapter: Byte = 0;

Implementation

Uses MKFile, MKString, MKDos,
  {$IFDEF WINDOWS}
  WinDos;
  {$ELSE}
  Dos;
  {$ENDIF}


Function LanInstalled: Boolean;
  Begin
  Asm
    Mov ah, $00;
    Int $2a;
    Mov @Result, ah;
    End;
  End;


Procedure InitializeNCB(Var NCB: NCBType);
  Begin
  FillChar(NCB, SizeOf(NCBType), 0);
  NCB.ReturnCode := $ff;
  NCB.AdapterNum := LanAdapter;
  FillChar(NCB.NameLocal,SizeOf(NCB.NameLocal),' ');
  FillChar(NCB.NameRemote,SizeOf(NCB.NameRemote),' ');
  End;


Function NBIntr(Var NCB: NCBType): Byte;
  Var
    NSeg: Word;
    NOfs: Word;

  Begin
  NSeg := Seg(NCB);
  NOfs := Ofs(NCB);
  Asm
    Mov ah, $04;
    Mov al, $00;
    Mov es, NSeg;
    Mov bx, NOfs;
    Int $2a;
    Mov @Result, al;
    End;
  End;



Function NBAddName(Name: String; Var NameNum: Byte): Byte;
  Var
    NCB: NCBType;

  Begin
  InitializeNCB(NCB);
  NCB.Command := $30; {add name to name table}
  If Length(Name) > 16 Then
    Name[0] := #16;
  Move(Name[1], NCB.NameLocal, Length(Name));
  NBAddName := NBIntr(NCB);
  NameNum := NCB.NcbNum;
  End;


Function NBDeleteName(Name: String): Byte;
  Var
    NCB: NCBType;

  Begin
  InitializeNCB(NCB);
  NCB.Command := $31; {add name to name table}
  If Length(Name) > 16 Then
    Name[0] := #16;
  Move(Name[1], NCB.NameLocal, Length(Name));
  NBDeleteName := NBIntr(NCB);
  End;


Function  NBGetStatus(Name: String; Var NBStat: NBStatusType): Byte;
  Var
    NCB: NCBType;

  Begin
  InitializeNCB(NCB);
  NCB.Command := $34; {add name to name table}
  If Length(Name) > 16 Then
    Name[0] := #16;
  Move(Name[1], NCB.NameLocal, Length(Name));
  NCB.Buffer := @NBStat;
  NCB.BufferLen := SizeOf(NBStat);
  NBGetStatus := NBIntr(NCB);
  End;


Function  NBCall(RemoteName: String; LocalName: String; Var NCB: NCBType): Byte;
  Var
    Temp: Byte;

  Begin
  InitializeNCB(NCB);
  NCB.Command := $90; {add name to name table}
  If Length(RemoteName) > 16 Then
    RemoteName[0] := #16;
  Move(RemoteName[1], NCB.NameRemote, Length(RemoteName));
  If Length(LocalName) > 16 Then
    LocalName[0] := #16;
  Move(LocalName[1], NCB.NameLocal, Length(LocalName));
  NCB.TimeOut := 5;
  NCB.SendTimeOut := 5;
  Temp := NBIntr(NCB);
  If Temp = 0 Then
    NBCall := NBCallFinished(NCB, 100)
  Else
    NBCall := Temp;
  End;


Function  NBListen(RemoteName: String; LocalName: String; Var NCB: NCBType): Byte;
  Var
    Temp: Byte;

  Begin
  InitializeNCB(NCB);
  NCB.Command := $91; {add name to name table}
  If Length(RemoteName) > 16 Then
    RemoteName[0] := #16;
  Move(RemoteName[1], NCB.NameRemote, Length(RemoteName));
  If Length(LocalName) > 16 Then
    LocalName[0] := #16;
  Move(LocalName[1], NCB.NameLocal, Length(LocalName));
  NCB.TimeOut := 5;
  NCB.SendTimeOut := 5;
  Temp := NBIntr(NCB);
  If Temp = 0 Then
    NBListen := NBCallFinished(NCB, 100)
  Else
    NBListen := Temp;
  End;


Function NBSendString(Var NCB: NCBType; LSN: Byte; Var Str: String): Byte;
  Begin
  NBSendString := NBSendStringLimit(NCB, LSN, Str, 100);
  End;


Function  NBSendStringLimit(Var NCB: NCBType; LSN: Byte; Var Str: String; TLimit: LongInt): Byte;
  Var
    Tmp: Word;

  Begin
  InitializeNCB(NCB);
  NCB.LSN := LSN;
  NCB.Buffer := @Str;
  NCB.BufferLen := Length(Str) + 1;
  NCB.Command := $94;
  Tmp := NBIntr(NCB);
  If Tmp = 0 Then
    NBSendStringLimit := NBCallFinished(NCB, TLimit)
  Else
    NBSendStringLimit := Tmp;
  End;


Function  NBSendStringNW(Var NCB: NCBType; LSN: Byte; Var Str: String): Byte;
  Begin
  InitializeNCB(NCB);
  NCB.LSN := LSN;
  NCB.Buffer := @Str;
  NCB.BufferLen := Length(Str) + 1;
  NCB.Command := $94;
  NBSendStringNW := NBIntr(NCB);
  End;


Function  NBSendBlockNW(Var NCB: NCBType; LSN: Byte; Var Buffer; BLen: Word): Byte;
  Begin
  InitializeNCB(NCB);
  NCB.LSN := LSN;
  NCB.Buffer := @Buffer;
  NCB.BufferLen := BLen;
  NCB.Command := $94;
  NBSendBlockNW := NBIntr(NCB);
  End;


Function  NBRecvStringLimit(Var NCB: NCBType; LSN: Byte; Var Str: String; TLimit: LongInt): Byte;
  Var
    Tmp: Word;

  Begin
  InitializeNCB(NCB);
  NCB.LSN := LSN;
  NCB.Buffer := @Str;
  NCB.BufferLen := 256;
  NCB.Command := $95;
  Tmp := NBIntr(NCB);
  If Tmp = 0 Then
    NBRecvStringLimit := NBCallFinished(NCB, TLimit)
  Else
    NBRecvStringLimit := Tmp;
  End;


Function  NBRecvStringNW(Var NCB: NCBType; LSN: Byte; Var Str: String): Byte;
  Begin
  InitializeNCB(NCB);
  NCB.LSN := LSN;
  NCB.Buffer := @Str;
  NCB.BufferLen := 256;
  NCB.Command := $95;
  NBRecvStringNW := NBIntr(NCB);
  End;


Function  NBRecvString(Var NCB: NCBType; LSN: Byte; Var Str: String): Byte;
  Begin
  NBRecvString := NBRecvStringLimit(NCB, LSN, Str, 100);
  End;


Function  NBHangUp(LSN: Byte): Byte;
  Var
    NCB: NCBType;

  Begin
  InitializeNCB(NCB);
  NCB.LSN := LSN;
  NCB.Command := $12;
  NBHangUp := NBIntr(NCB);
  End;


Function NBCallFinished(Var NCB: NCBType; NBLimit: LongInt): Byte;
  Var
    NBTimeOut: LongInt;
    RCode: Byte;

   {NBLimit = 100 means 100/18.2 = 5.5 seconds}

  Begin
  NBTimeOut := TimeCounter + NBLimit;
    While ((NCB.CompleteCode = $ff) and (Not TimeOut(NBTimeOut))) Do;
  If TimeOut(NBTimeOut) Then
    Begin
    RCode := NBCancel(NCB);
    Case RCode of
      $24: NBCallFinished := NCB.ReturnCode; {Completed during cancel}
      $00: NBCallFinished := 254; {Timed-out cancel ok}
      $26: Begin
           NBCallFinished := NCB.ReturnCode;
           End;
      Else
           Begin
           NBCallFinished := 253;
           End;
      End;
    End
  Else
    NBCallFinished := NCB.ReturnCode;
  End;


Function  NBCancel(Var NCB: NCBType): Byte; {Cancel pending request}
  Var
    CancelNCB: NCBType;

  Begin
  InitializeNCB(CancelNCB);
  CancelNCB.Command := $35;
  CancelNCB.Buffer := @NCB;
  NBCancel := NBIntr(CancelNCB);
  End;

End.
